//Ikariam Projections user script
//version 0.1 BETA!
//2011−05−12
//Copyright (c) 2011, Nick Andriopoulos
//Released under the GPL license
//http://www.gnu.org/copyleft/gpl.html
//−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−
//This is a Greasemonkey user script.
//To install, you need Greasemonkey: http://greasemonkey.mozdev.org/
//Then restart Firefox and revisit this script.
//Under Tools, there will be a new menu item to "Install User Script".
//Accept the default configuration and install.
//To uninstall, go to Tools/Manage User Scripts,
//select "Ikariam Projections", and click Uninstall.
//−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−−
//==UserScript==
//@name Ikariam Projections
//@description Generates projections from town hall about happiness, growth, and income over the next 24h
//@include http://s*.ikariam.*/*
//@exclude http://board.ikariam.*/*
//@require https://www.google.com/jsapi
//==/UserScript==

window.addEventListener('load',  function() {
  try {
    var page = document.getElementsByTagName('body')[0].id;
    if (page == 'townHall') {

      // Inject HTML elements (view button, chart area)
      inject_ika_proj();
      
    }
  } catch(er) {
    var debug_mode 	= GM_getValue('debug_mode','0');
  }
},true);
	
function inject_ika_proj() 
{
// Inject the View Projection button
var happy_area = document.getElementById('happiness_small');
	happy_area.innerHTML += "</li><li style=\"left: 278px; top: 110px;\" class=\"view-projections\"><h3 ><a id=\"ika-proj-link\" style=\"font-weight: bold; text-align: center;\">View projections</a></h3></li>";

// Inject the Chart div
var main = document.getElementById('PopulationGraph');
if (main) { 
  newElement = document.createElement('div');
  newElement.innerHTML = '<div id="ika-proj-data" style="display:none; height:380px;margin-left:15px;"><div id="ika-proj-chart"></div></div>';
  main.parentNode.insertBefore(newElement, main);
}
	
	document.getElementById('ika-proj-link').addEventListener('click',function() {togglebox('ika-proj-data');},true);
}	
	
//window.togglebox = function(name)
function togglebox(name)
{
var getdisplay = document.getElementById(name).style.display;
if (getdisplay == 'block') {
	document.getElementById(name).style.display="none";
} else {
  // If this is the first time we're being clicked, get the chart
  var chart = document.getElementById('ika-proj-chart').childNodes[0];
  if ( chart ) {
  } else {
    drawChart();
  }
  document.getElementById(name).style.display='block';
  	
	}
	
}

function drawChart() {
  var gstock = document.getElementById('value_gold').innerHTML.replace(',','');
  var growth = document.getElementById('populationGrowth').childNodes[3].childNodes[0].innerHTML;
  var curnet = document.getElementById('incomeGoldValue').innerHTML;
  var happy  = document.getElementById('happinessLarge').childNodes[0].childNodes[1].innerHTML;

  var timewindow = 25;

  var datapoints = new Array(4);
  var minmax = new Array(6);
  for(i=0;i<4;i=i+1) { datapoints[i] = new Array(timewindow); }
  
  // Initial datapoints
  datapoints[0][0] = parseInt(happy);       // Initial happyness
  datapoints[1][0] = parseFloat(growth);      // Initial growth rate
  datapoints[2][0] = parseInt(curnet);      // Initial net gold
  datapoints[3][0] = parseInt(gstock);      // Initial gold stock
  minmax[0] = datapoints[3][0];
  minmax[1] = datapoints[3][0];
  minmax[2] = datapoints[0][0];
  minmax[3] = datapoints[0][0];
  minmax[4] = datapoints[2][0];
  minmax[5] = datapoints[2][0];

  for ( i=1;i<timewindow;i=i+1 ) {
    // Happyness at i hours
    datapoints[0][i] = Math.round(datapoints[0][i-1] - datapoints[1][i-1]);   // Current happyness = previous hapyness - growth
    datapoints[1][i] = Math.round((datapoints[0][i] * 0.02)*100)/100;               // Current growth is always 0.02*(current happiness)
    datapoints[2][i] = Math.round(datapoints[2][i-1] + 3*datapoints[1][i-1]); // Current net gold = prev net gold * extra gold produced by growth
    datapoints[3][i] = Math.round(datapoints[3][i-1] + datapoints[2][i-1]);   // Current Gold stock = prev gold stock + prev net gold
    
    //alert('State '+i+': '+datapoints[3][i]+','+datapoints[0][i]+','+datapoints[2][i]);

    
    if ( datapoints[3][i] < minmax[0] ) minmax[0] = datapoints[3][i];
    if ( datapoints[3][i] > minmax[1] ) minmax[1] = datapoints[3][i];
    if ( datapoints[0][i] < minmax[2] ) minmax[2] = datapoints[0][i];
    if ( datapoints[0][i] > minmax[3] ) minmax[3] = datapoints[0][i];
    if ( datapoints[2][i] < minmax[4] ) minmax[4] = datapoints[2][i];
    if ( datapoints[2][i] > minmax[5] ) minmax[5] = datapoints[2][i];
  }
  
  var url = "http://chart.googleapis.com/chart?cht=lc&chtt=Ikariam+Projections&chs=650x350&chd=t:" + 
    datapoints[3].join(',') + '|' + datapoints[0].join(',') + '|' + datapoints[2].join(',') +
    '&chds='+ minmax.join(',') + '&chxt=x,y,y,r&chco=FF0000,00FF00,0000FF&chdl=Gold+Stock|Happiness|Net+Income&chdlp=t&chma=30,30,20,50&chxr=0,0,24|1,' +
    minmax[0] + ',' + minmax[1] + '|2,' + minmax[2] + ',' + minmax[3] + '|3,' + minmax[4] + ',' + minmax[5] +
    '&chxs=0,555555,12,0,lt|1,FF0000,10,1,lt|2,00FF00,10,0,lt|3,0000FF,10,0,lt&chf=bg,s,fdf7dd';
  
  document.getElementById('ika-proj-chart').innerHTML = '<img src="'+url+'" />';  
    
}
